import AbstractLogger from './Logger.ts'
import { LogMessage } from './types.ts'
import { gray, cyan } from '../../external/std.ts'

export default class StandardLogger extends AbstractLogger {
    public async write(message: LogMessage): Promise<void> {
        const prefix = this.level_display(message.level)
        const text = `${prefix} ${gray(this.format_date(message.date))} (${cyan(message.caller_name || 'Unknown')})`
        console.log(text, message.output)
    }
}
